#include <iostream>

using namespace std;

int main()
{
    int N,O,A,B,AB,i;
    cin>>N;
    cin>>O>>A>>B>>AB;
    string pacijent_grupa[N];
    int pacijent_kolicina[N];
    int pacijent_O[N];
    int pacijent_A[N];
    int pacijent_B[N];
    int pacijent_AB[N];
    for(i=0;i<N;i++)
    {
        cin>>pacijent_grupa[i];
        cin>>pacijent_kolicina[i];
        pacijent_O[i]=0;
        pacijent_A[i]=0;
        pacijent_B[i]=0;
        pacijent_AB[i]=0;
    }
    for(i=0;i<N;i++)
    {
        if(pacijent_grupa[i]=="O")
        {
            O=O-pacijent_kolicina[i];
            if(O<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            pacijent_O[i]=pacijent_O[i]+pacijent_kolicina[i];
        }
    }
    for(i=0;i<N;i++)
    {
        if(pacijent_grupa[i]=="A")
        {
            for(;pacijent_kolicina[i]>0;pacijent_kolicina[i]--)
            {
                if(A>0)
                {
                    A=A-1;
                    pacijent_A[i]=pacijent_A[i]+1;
                }
                else
                {
                    O=O-pacijent_kolicina[i];
                    pacijent_O[i]=pacijent_O[i]+pacijent_kolicina[i];
                }
                if(O<0)
                {
                    cout<<"nemoguce";
                    return 0;
                }
            }
        }
    }
    for(i=0;i<N;i++)
    {
        if(pacijent_grupa[i]=="B")
        {
            for(;pacijent_kolicina[i]>0;pacijent_kolicina[i]--)
            {
                if(B>0)
                {
                    B=B-1;
                    pacijent_B[i]=pacijent_B[i]+1;
                }
                else
                {
                    O=O-pacijent_kolicina[i];
                    pacijent_O[i]=pacijent_O[i]+pacijent_kolicina[i];
                }
                if(O<0)
                {
                    cout<<"nemoguce";
                    return 0;
                }
            }
        }
    }
    for(i=0;i<N;i++)
    {
        if(pacijent_grupa[i]=="AB")
        {
            for(;pacijent_kolicina[i]>0;pacijent_kolicina[i]--)
            {
                if(AB>0)
                {
                    AB=AB-1;
                    pacijent_AB[i]=pacijent_AB[i]+1;
                }
                else if(A>0)
                {
                    A=A-1;
                    pacijent_A[i]=pacijent_A[i]+1;
                }
                else if(B>0)
                {
                    B=B-1;
                    pacijent_B[i]=pacijent_B[i]+1;
                }
                else
                {
                    O=O-pacijent_kolicina[i];
                    pacijent_O[i]=pacijent_O[i]+pacijent_kolicina[i];
                }
                if(O<0)
                {
                    cout<<"nemoguce";
                    return 0;
                }
            }
        }
    }
    cout<<"moguce"<<endl;
    for(i=0;i<N;i++)
    {
        cout<<pacijent_O[i]<<" "<<pacijent_A[i]<<" "<<pacijent_B[i]<<" "<<pacijent_AB[i]<<endl;
    }
    return 0;
}